/* 페이징 관련 변수 */
let webYouTubeTotalCount   = 0;
let webYouTubeTotalPages   = 0;

/*aggird*/
let webYouTubeAgGridData = [];

let webYouTubeSelectId = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_webYouTubeSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchStartDate = year+'-'+month+'-'+day;
        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        webYouTubeSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webYouTubeSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webYouTubeSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webYouTubeSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webYouTubeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webYouTubeSearchStartDate = year+'-01-01';
    }

    $("#webYouTubeSearchStartDate").val(webYouTubeSearchStartDate).trigger("change");
    $("#webYouTubeSearchEndDate").val(webYouTubeSearchEndDate).trigger("change");
}


/****************************************************************************
 * 유튜브 정보 리스트 조회
 ****************************************************************************/
function fn_selectListWebYouTubeJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("webYouTubeSearchKeywordParam", webYouTubeSearchKeywordParam);
    formData.append("webYouTubeSort", webYouTubeSort);
    formData.append("webYouTubeDir", webYouTubeDir);
    formData.append("webYouTubeStart", webYouTubeStart);
    formData.append("webYouTubeLimit", webYouTubeLimit);
    formData.append("webYouTubeSearchStartDate", webYouTubeSearchStartDate);
    formData.append("webYouTubeSearchEndDate", webYouTubeSearchEndDate);
    formData.append("webYouTubeSearchDateType", webYouTubeSearchDateType);

    $.ajax({
        url: encodeURI('/webyoutube/selectListWebYouTube.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                webYouTubeTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                webYouTubeTotalPages = Math.ceil(webYouTubeTotalCount/webYouTubeLimit);

                // 리스트 조회
                webYouTubeAgGridData = data.rows;
                webYouTubeGridOptions.api.setRowData(webYouTubeAgGridData);

                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#webYouTubePagination').twbsPagination({
                        startPage    : ((webYouTubeStart/webYouTubeLimit)+1),
                        totalPages   : (webYouTubeTotalPages==0)?1:webYouTubeTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (event, page) {
                            fn_webYouTubePagination(page);
                        }
                    }).on('page', function (event, page) {
                        //console.info(page + ' (from event listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            webYouTubeGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_webYouTubeSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_webYouTubePaginReset();

    webYouTubeSearchKeywordParam = $("#webYouTubeSearchKeyword").val();

    webYouTubeSearchDateType  = $("#webYouTubeSearchDateType").val();
    webYouTubeSearchStartDate = $("#webYouTubeSearchStartDate").val();
    webYouTubeSearchEndDate   = $("#webYouTubeSearchEndDate").val();

    fn_selectListWebYouTubeJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_webYouTubeReset(){
    fn_webYouTubeSetDate('D');
    $("#webYouTubeSearchDateType option:eq(0)").prop("selected", true);

    $("#webYouTubeSearchKeyword").val("");

    fn_webYouTubeSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_webYouTubePagination(param){
    webYouTubeStart = (parseInt(param)-1)*webYouTubeLimit;

    fn_selectListWebYouTubeJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_webYouTubePaginReset(){
    webYouTubeSearchKeywordParam = '';

    webYouTubeStart        = 0;
    webYouTubeLimit        = 100;
    webYouTubeTotalCount   = 0;
    webYouTubeTotalPages   = 0;

    //페이징 초기화
    if($("#webYouTubePagination").data("twbs-pagination")){
        $("#webYouTubePagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 유튜브 삭제
 ****************************************************************************/
function fn_deleteWebYouTube(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!webYouTubeSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    modalEvent.info("삭제", "선택한 유튜브 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", webYouTubeSelectId);

        $.ajax({
            url: encodeURI('/webyoutube/deleteWebYouTube.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_webYouTubeOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 이벤트
 ****************************************************************************/
function fn_webYouTubeEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_webYouTubeSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == event.keyCode) {
            //로그인 액션 스크립트
            fn_webYouTubeSearch();
        }
    }
}

/****************************************************************************
 * 정렬 이벤트
 ****************************************************************************/
function fn_alignContent(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_webYouTubeSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_webYouTubeSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_webYouTubeSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_webYouTubeSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_webYouTubeSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_webYouTubeSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_webYouTubeSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_webYouTubeSetDate('I');
    }
    else{
        align = "";
    }
    $("#webYouTubeSearchDateType").val(param);
    $("#webYouTubeSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_webYouTubeOk(){
    fn_webYouTubeReset();
}

/****************************************************************************
 * 등록 화면으로 이동.
 ****************************************************************************/
function fn_insertWebYouTubeIntro(){
    if("Y"==insertUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webyoutube/insertWebYouTubeIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }
}

/****************************************************************************
 * 수정 화면으로 이동.
 ****************************************************************************/
function fn_updateWebYouTubeIntro(muWebYouTubeId){
    if("Y"==updateUseYn){
        let pagingParam = "?menuClass="+menuClass;
        pagingParam    += "&muWebYouTubeId="+muWebYouTubeId;
        fn_leftFormAction("/webyoutube/updateWebYouTubeIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "수정 권한이 없습니다.");
        return false;
    }
}

let webYouTubeColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
    /* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
    {field: "rowNum", headerName:"번호", minWidth:60, maxWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
    {field: "title", headerName:"제목", minWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
    {field: "url", headerName:"URL",minWidth:500},
    {field: "writeDate", headerName:"등록일",minWidth:150, maxWidth:150},
    {field: "writeName", headerName:"작성자",minWidth:150, maxWidth:150},
];

// let the grid know which columns and what data to use
let webYouTubeGridOptions = {
    suppressRowTransform: true,
    columnDefs: webYouTubeColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : webYouTubeAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(event){ //셀 클릭 이벤트
        /* alert(event.column.colId); */
        if('title'==event.column.colId){
            fn_updateWebYouTubeIntro(event.data.muWebYouTubeId);
        }
    },
    onSelectionChanged: function(event){ //체크박스 선택
        let selectRows = [];
        selectRows = event.api.getSelectedRows();

        webYouTubeSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            webYouTubeSelectId += selectRows[i].muWebYouTubeId + ",";
        }
        webYouTubeSelectId = webYouTubeSelectId.substring(0, webYouTubeSelectId.lastIndexOf(','));
    },
    onSortChanged: function(event){
        //정렬
        webYouTubeSort = ''; //기존 정렬 초기화
        let columnArr = event.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    webYouTubeStart = 0;
                    webYouTubeSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        webYouTubeSort = '';
                        webYouTubeDir = '';
                        webYouTubeStart = 0;
                    }
                }
            }
        }
        webYouTubeSort = webYouTubeSort.substring(0,webYouTubeSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_webYouTubeSearch();
    }
};

// lookup the container we want the Grid to use
let webYouTubeGridDiv = document.querySelector('#webYouTubeGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(webYouTubeGridDiv, webYouTubeGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divWebYouTubeSearchStartDate", "#divWebYouTubeSearchEndDate");

    if(!webYouTubeSearchStartDate&&!webYouTubeSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_webYouTubeSetDate('D');
    }else{
        $("#webYouTubeSearchStartDate").val(webYouTubeSearchStartDate).trigger("change");
        $("#webYouTubeSearchEndDate").val(webYouTubeSearchEndDate).trigger("change");
    }

    // 초기 페이징 처리
    $("#webYouTubeSearchKeyword").val(webYouTubeSearchKeywordParam);

    fn_webYouTubeSearch("A");
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $(document).on('keypress', '#webYouTubeSearchKeyword', function(e) {
        fn_webYouTubeEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchWebYouTube").click(function () {
        fn_webYouTubeSearch();
    });

    // 유튜브 등록 팝업 버튼
    $("#btnInsertWebYouTube").click(function () {
        fn_insertWebYouTubeIntro();
    });

    // 유튜브 삭제 버튼
    $("#btnDeleteWebYouTube").click(function () {
        fn_deleteWebYouTube();
    });

    // 기간 선택 콤보 이벤트
    const target = $("#webYouTubeSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignContent(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});